diff options
author | Junio C Hamano <gitster@pobox.com> | 2008-06-25 13:18:46 -0700 |
---|---|---|
committer | Junio C Hamano <gitster@pobox.com> | 2008-06-25 13:18:46 -0700 |
commit | 14f0e48db7e1b0c5ec1b831f47214b972b4582d4 (patch) | |
tree | f9c025835b2e9509a82e87aa7fe280dd732160fe /t/test-lib.sh | |
parent | 85fe23ed2a5d88463f5362a3e4fdd6f45a0555fd (diff) | |
parent | b4780d725c673db26692e11c56539381d60ad17c (diff) | |
download | git-14f0e48db7e1b0c5ec1b831f47214b972b4582d4.tar.gz git-14f0e48db7e1b0c5ec1b831f47214b972b4582d4.tar.xz |
Merge branch 'lw/perlish'
* lw/perlish:
Git.pm: add test suite
t/test-lib.sh: add test_external and test_external_without_stderr
Diffstat (limited to 't/test-lib.sh')
-rw-r--r-- | t/test-lib.sh | 58 |
1 files changed, 58 insertions, 0 deletions
diff --git a/t/test-lib.sh b/t/test-lib.sh index e331cadcf..f4f35ed43 100644 --- a/t/test-lib.sh +++ b/t/test-lib.sh @@ -304,6 +304,64 @@ test_expect_code () { echo >&3 "" } +# test_external runs external test scripts that provide continuous +# test output about their progress, and succeeds/fails on +# zero/non-zero exit code. It outputs the test output on stdout even +# in non-verbose mode, and announces the external script with "* run +# <n>: ..." before running it. When providing relative paths, keep in +# mind that all scripts run in "trash directory". +# Usage: test_external description command arguments... +# Example: test_external 'Perl API' perl ../path/to/test.pl +test_external () { + test "$#" -eq 3 || + error >&5 "bug in the test script: not 3 parameters to test_external" + descr="$1" + shift + if ! test_skip "$descr" "$@" + then + # Announce the script to reduce confusion about the + # test output that follows. + say_color "" " run $(expr "$test_count" + 1): $descr ($*)" + # Run command; redirect its stderr to &4 as in + # test_run_, but keep its stdout on our stdout even in + # non-verbose mode. + "$@" 2>&4 + if [ "$?" = 0 ] + then + test_ok_ "$descr" + else + test_failure_ "$descr" "$@" + fi + fi +} + +# Like test_external, but in addition tests that the command generated +# no output on stderr. +test_external_without_stderr () { + # The temporary file has no (and must have no) security + # implications. + tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi + stderr="$tmp/git-external-stderr.$$.tmp" + test_external "$@" 4> "$stderr" + [ -f "$stderr" ] || error "Internal error: $stderr disappeared." + descr="no stderr: $1" + shift + say >&3 "expecting no stderr from previous command" + if [ ! -s "$stderr" ]; then + rm "$stderr" + test_ok_ "$descr" + else + if [ "$verbose" = t ]; then + output=`echo; echo Stderr is:; cat "$stderr"` + else + output= + fi + # rm first in case test_failure exits. + rm "$stderr" + test_failure_ "$descr" "$@" "$output" + fi +} + # This is not among top-level (test_expect_success | test_expect_failure) # but is a prefix that can be used in the test script, like: # |